import { TABLE_NAME } from 'src/core/strings/constants/table.constants';
import {
  DataSchedulingLogEntity,
  SCHEDULING_LOG_ACTION_ENUM,
  SCHEDULING_LOG_TYPE_ENUM,
} from '../../domain/entities/data-scheduling.entity';
import { Column, Entity } from 'typeorm';
import { BaseStatusModel } from 'src/core/modules/data/model/base-status.model';

@Entity(TABLE_NAME.DATA_SCHEDULING_LOG)
export class DataSchedulingLogModel
  extends BaseStatusModel<DataSchedulingLogEntity>
  implements DataSchedulingLogEntity
{
  @Column({ type: 'enum', enum: SCHEDULING_LOG_TYPE_ENUM, nullable: false })
  type: SCHEDULING_LOG_TYPE_ENUM;

  @Column({ type: 'enum', enum: SCHEDULING_LOG_ACTION_ENUM, nullable: false })
  action: SCHEDULING_LOG_ACTION_ENUM;

  @Column({ type: 'bigint', nullable: false })
  log_created_at: number;

  @Column('varchar', { name: 'data_id', nullable: true })
  data_id: string;

  @Column('varchar', { name: 'name', nullable: true })
  name: string;

  @Column('varchar', { name: 'indexing_key', nullable: true })
  indexing_key: string;

  @Column('date', { name: 'schedule_date_from', nullable: true })
  schedule_date_from: Date;

  @Column('date', { name: 'schedule_date_to', nullable: true })
  schedule_date_to: Date;

  @Column('int', { nullable: true })
  default_value: number;

  @Column('text', { name: 'description', nullable: true })
  description: string;
}
