import { BaseStatusEntity } from 'src/core/modules/domain/entities/base-status.entity';
import { BaseEntity } from 'src/core/modules/domain/entities/base.entity';
import { STATUS } from 'src/core/strings/constants/base.constants';

export interface DataSchedulingEntity extends BaseStatusEntity {
  name: string;
  indexing_key: number | string;
  schedule_date_from: Date;
  schedule_date_to: Date;
}

export interface DataSchedulingDefaultEntity extends BaseEntity {
  default_value: number;
}

export interface DataSchedulingActiveEntity {
  value: number;
}

export enum SCHEDULING_LOG_TYPE_ENUM {
  DEFAULT_PERCENTAGE = 'Default Percentage',
  DATA_SCHEDULING = 'Data Scheduling',
}

export enum SCHEDULING_LOG_ACTION_ENUM {
  CREATE = 'CREATE',
  UPDATE = 'UPDATE',
  DELETE = 'DELETE',
  CHANGE_STATUS = 'CHANGE_STATUS',
}

export interface DataSchedulingLogEntity extends BaseStatusEntity {
  type: SCHEDULING_LOG_TYPE_ENUM;
  action: SCHEDULING_LOG_ACTION_ENUM;
  log_created_at: number;

  data_id?: string;

  name?: string;
  indexing_key?: number | string;
  schedule_date_from?: Date;
  schedule_date_to?: Date;

  default_value?: number;

  description?: string;
}
