import { BaseFilterDto } from 'src/core/modules/infrastructure/dto/base-filter.dto';
import { FilterDataSchedulingEntity } from '../../domain/entities/filter-data-scheduling.entity';
import { ApiProperty } from '@nestjs/swagger';
import { ValidateIf } from 'class-validator';

export class FilterDataSchedulingDto
  extends BaseFilterDto
  implements FilterDataSchedulingEntity
{
  @ApiProperty({ type: 'string', required: false })
  @ValidateIf((body) => body.schedule_date_from)
  schedule_date_from: Date;

  @ApiProperty({ type: 'string', required: false })
  @ValidateIf((body) => body.schedule_date_to)
  schedule_date_to: Date;
}

export class FilterDataSchedulingLogDto
  extends BaseFilterDto
  implements FilterDataSchedulingEntity
{
  @ApiProperty({ type: 'string', required: false })
  @ValidateIf((body) => body.schedule_date_from)
  schedule_date_from: Date;

  @ApiProperty({ type: 'string', required: false })
  @ValidateIf((body) => body.schedule_date_to)
  schedule_date_to: Date;

  @ApiProperty({ type: Number, required: false })
  @ValidateIf((body) => body.log_created_from)
  log_created_from: number;

  @ApiProperty({ type: Number, required: false })
  @ValidateIf((body) => body.log_created_to)
  log_created_to: number;
}

export class FilterActiveDataSchedulingDto {
  // @ApiProperty({ type: 'string', required: true })
  // @ValidateIf((body) => body.schedule_date_from)
  // date: Date;
}
